//###########################################################################
// FILE:	CCANPhysicalLayer.h
// TITLE:	This file include the CAN Physical Layer .
//###########################################################################
#ifndef CCANPhysicalLayer_H
#define CCANPhysicalLayer_H

#include "CCANGlobalDef.h"

#ifdef __cplusplus
extern "C" {
#endif

#define POWER_SUPPLY_RETURN_VOLTAGE_ID  0x85000308//0x80000101

//////////////////////////////////////////////////////////////////////
//        ****** CCANPhysicalLayer Class ******
//////////////////////////////////////////////////////////////////////
class CCANPhysicalLayer 
{    
private:
	CCANPhysicalLayer();
	~CCANPhysicalLayer();
	static CCANPhysicalLayer *m_pCanInstancePtr;
	void CanMailboxConfig(Bool bDir, Uint16 uiMBNunmer, Uint32 uiMSGID,Bool bOPC,Bool bEnableInt, Uint32 uiMaskID);
	void SetRxFifoMailboxes(Uint16 uiFirstMBXfifo, Uint16 uiLastMBXfifo);
	Uint16 m_uiFirstMBXfifo;
	Uint16 m_uiLastMBXfifo;
	CAN_INTERFACE_NUM m_CanBusSelection; // CanA or CanB
	ECAN_REGS * m_pCanRegs;
	ECAN_MBOXES * m_pCanMBoxes;
public:
  	void HWconfig(CAN_INTERFACE_NUM CanBusSelect); 	
	void Init(); 		
	STATUS TransmitMsg(CAN_MESSAGE * pCan_Bus_Data,Uint16 uiTxPriority,Uint32 nCountToWait = CAN_TRANSMIT_TIMEOUT);
	STATUS ReceiveFifoMsg(CAN_MESSAGE * pCan_Bus_Data);
	STATUS ReceiveSpecialMbx(CAN_MESSAGE * pCan_Bus_Data, Uint16 MailBox_Serial_Number);
	static CCANPhysicalLayer* Getinstance()
	{
		if (!m_pCanInstancePtr)

		//if (NULL == m_pCanInstancePtr)
			m_pCanInstancePtr = new CCANPhysicalLayer;
		return m_pCanInstancePtr;
	}
	Uint16 uiBoard_Id;
};


//---------------------------------------------------------------------------
#ifdef __cplusplus
}
#endif /* extern "C" */

#endif  

/*** end of file *****************************************************/
