/*
 *  ======== main.c ========
 */

#include <xdc/std.h>

#include <xdc/runtime/System.h>

#include <ti/sysbios/BIOS.h>

#include <ti/sysbios/knl/Clock.h>
#include <ti/sysbios/knl/Task.h>
#include <ti/sysbios/knl/Semaphore.h>

#include "CCANDataLinkLayer.h"
#include <xdc/cfg/global.h>
#include "CCANDataLinkLayer.h"

#include <xdc/runtime/Log.h>

#include <stdlib.h>
#include <string.h>
#include "CCANGlobalDef.h"
#include "CBaseSubSystem.h"
#include <xdc/cfg/global.h>

CCANDataLinkLayer *pCANDataLinkLayer;


/*
 *  ======== taskFxn ========
 */

/*
 *  ======== main ========
 */
extern "C" {

/* Wrapper functions to call Clock::tick() */


void TaskCanReceive()
   	{
	    Log_info0("TaskCanReceive Calling ");
	    pCANDataLinkLayer->HandleReceivePacket();
   	}



   void TaskInit()
  	{
		Log_info0("TaskInit start\n");
		pCANDataLinkLayer = (CCANDataLinkLayer *)CCANDataLinkLayer::Getinstance();
		if(pCANDataLinkLayer == NULL)
		{

			Log_info0("pCANDataLinkLayer = NULL ERROR!!!");
	   }

    	//InitSysCtrl();
		pCANDataLinkLayer->Init(CAN_A_INTERFACE);
		// register BOARD as can SubSystem user
		//pCANDataLinkLayer->Register(SUBSYSTEM_TYPE_BOARD, (CBaseSubSystem *)1);
		// If there is sub system that using CAN - register here !!!

		Log_info0("TaskInit End ");
		//initTaskParams.priority = -1;
		Task_exit();

   	}





 } // end extern "C"




void InitSysCtrl(void)
{

   // Disable the watchdog
   DisableDog();


        EALLOW;
        SysCtrlRegs.PCLKCR0.bit.ADCENCLK = 1; // Enable ADC peripheral clock
        //(*Device_cal)();
        SysCtrlRegs.PCLKCR0.bit.ADCENCLK = 0; // Return ADC clock to original state
        EDIS;

   // Select Internal Oscillator 1 as Clock Source (default), and turn off all unused clocks to
   // conserve power.
   IntOsc1Sel();
   // Initialize the PLL control: PLLCR and CLKINDIV
   // DSP28_PLLCR and DSP28_CLKINDIV are defined in DSP2803x_Examples.h
   InitPll(DSP28_PLLCR,DSP28_DIVSEL);
   // Initialize the peripheral clocks
   InitPeripheralClocks();
}
int main()
{ 


   InitSysCtrl();

   InitECanGpio();

   InitPieCtrl();
   InitPieVectTable();

   Log_info0("BIOS_start  ");
	BIOS_start();        /* enable interrupts and start SYS/BIOS */
     //InitECanGpio();


/*
	// Create task with priority 15
      Log_info0("Create task TaskInit start  ");
	  Task_Params_init(&initTaskParams);
	  initTaskParams.priority = 2;
	  Task_create((Task_FuncPtr)TaskInit, &initTaskParams, NULL);
	  Log_info0("Create task TaskInit end  ");


	  Log_info0("Create task TaskCanReceive start  ");
	  Task_Params_init(&TaskReceive);
	  TaskReceive.priority = 1;
	  Task_create((Task_FuncPtr)TaskCanReceive, &TaskReceive, NULL);
	  Log_info0("Create task TaskCanReceive end  ");

*/


	  /*
     * use ROV->SysMin to view the characters in the circular buffer
     */
	//InitSystem();



  }
